import { DeepReadonly } from 'utility-types';
import { ActionType } from 'typesafe-actions';
import * as actions from './actions';
export declare type State = DeepReadonly<{
    [key: string]: {
        loading: boolean;
        error?: Error;
        ids?: string | string[];
        meta?: any;
    };
}>;
export declare type QueryAction = ActionType<typeof actions>;
declare const queries: <Base extends {
    readonly [x: string]: {
        readonly loading: boolean;
        readonly error?: {
            readonly name: string;
            readonly message: string;
            readonly stack?: string;
        };
        readonly ids?: string | {
            readonly [x: number]: string;
            readonly length: number;
            readonly toString: () => string;
            readonly toLocaleString: () => string;
            readonly concat: {
                (...items: ConcatArray<string>[]): string[];
                (...items: (string | ConcatArray<string>)[]): string[];
            };
            readonly join: (separator?: string) => string;
            readonly slice: (start?: number, end?: number) => string[];
            readonly indexOf: (searchElement: string, fromIndex?: number) => number;
            readonly lastIndexOf: (searchElement: string, fromIndex?: number) => number;
            readonly every: (callbackfn: (value: string, index: number, array: readonly string[]) => unknown, thisArg?: any) => boolean;
            readonly some: (callbackfn: (value: string, index: number, array: readonly string[]) => unknown, thisArg?: any) => boolean;
            readonly forEach: (callbackfn: (value: string, index: number, array: readonly string[]) => void, thisArg?: any) => void;
            readonly map: <U>(callbackfn: (value: string, index: number, array: readonly string[]) => U, thisArg?: any) => U[];
            readonly filter: {
                <S extends string>(callbackfn: (value: string, index: number, array: readonly string[]) => value is S, thisArg?: any): S[];
                (callbackfn: (value: string, index: number, array: readonly string[]) => unknown, thisArg?: any): string[];
            };
            readonly reduce: {
                (callbackfn: (previousValue: string, currentValue: string, currentIndex: number, array: readonly string[]) => string): string;
                (callbackfn: (previousValue: string, currentValue: string, currentIndex: number, array: readonly string[]) => string, initialValue: string): string;
                <U>(callbackfn: (previousValue: U, currentValue: string, currentIndex: number, array: readonly string[]) => U, initialValue: U): U;
            };
            readonly reduceRight: {
                (callbackfn: (previousValue: string, currentValue: string, currentIndex: number, array: readonly string[]) => string): string;
                (callbackfn: (previousValue: string, currentValue: string, currentIndex: number, array: readonly string[]) => string, initialValue: string): string;
                <U>(callbackfn: (previousValue: U, currentValue: string, currentIndex: number, array: readonly string[]) => U, initialValue: U): U;
            };
            readonly find: {
                <S extends string>(predicate: (this: void, value: string, index: number, obj: readonly string[]) => value is S, thisArg?: any): S;
                (predicate: (value: string, index: number, obj: readonly string[]) => boolean, thisArg?: any): string;
            };
            readonly findIndex: (predicate: (value: string, index: number, obj: readonly string[]) => boolean, thisArg?: any) => number;
            readonly entries: () => IterableIterator<[number, string]>;
            readonly keys: () => IterableIterator<number>;
            readonly values: () => IterableIterator<string>;
            readonly includes: (searchElement: string, fromIndex?: number) => boolean;
        };
        readonly meta?: any;
    };
}>(base?: Base, action: import("typesafe-actions").PayloadAction<"QUERY_REQUEST", {
    key: string;
}> | import("typesafe-actions").PayloadAction<"QUERY_FAILURE", {
    key: string;
    error: Error;
}> | import("typesafe-actions").PayloadAction<"QUERY_RESPONSE", {
    key: string;
    ids: string | string[];
    meta?: any;
}>) => Base;
export default queries;
//# sourceMappingURL=reducer.d.ts.map